
#ifndef __MYRADIO_GPIO_H_
#define __MYRADIO_GPIO_H_

#include <stdint.h>

#include "stm32f10x.h"
#include "stm32f10x_gpio.h"
#include "stm32f10x_spi.h"
#include "board.h"

#define SPI_HARD

// #define READ_RF_SX12xx_DIO0() READ_BOARD_GPIOA()
// #define READ_RF_SX12xx_DIO1() READ_BOARD_GPIOD()
// #define READ_RF_SX12xx_DIO2() READ_BOARD_GPIOC()
// #define READ_RF_SX12xx_DIO3() READ_BOARD_GPIOF()
// #define READ_RF_SX12xx_DIO4() READ_BOARD_GPIOH()
// #define READ_RF_SX12xx_DIO5() READ_BOARD_GPIOG()
// #define RF_SX12xx_DIO0_H() BOARD_GPIOA_H()
// #define RF_SX12xx_DIO0_L() BOARD_GPIOA_L()
// #define RF_SX12xx_DIO1_H() BOARD_GPIOD_H()
// #define RF_SX12xx_DIO1_L() BOARD_GPIOD_L()
// #define RF_SX12xx_DIO2_H() BOARD_GPIOC_H()
// #define RF_SX12xx_DIO2_L() BOARD_GPIOC_L()
// #define RF_SX12xx_DIO3_H() BOARD_GPIOF_H()
// #define RF_SX12xx_DIO3_L() BOARD_GPIOF_L()
// #define RF_SX12xx_DIO4_H() BOARD_GPIOH_H()
// #define RF_SX12xx_DIO4_L() BOARD_GPIOH_L()
// #define RF_SX12xx_DIO5_H() BOARD_GPIOG_H()
// #define RF_SX12xx_DIO5_L() BOARD_GPIOG_L()

// #define RF_SX12xx_RST_H() BOARD_GPIOB_H()
// #define RF_SX12xx_RST_L() BOARD_GPIOB_L()
#define READ_RF_SX12xx_DIO0() READ_BOARD_GPIOB()
#define READ_RF_SX12xx_DIO1() READ_BOARD_GPIOC()
#define READ_RF_SX12xx_DIO2() READ_BOARD_GPIOD()
#define READ_RF_SX12xx_DIO3() READ_BOARD_GPIOE()
#define READ_RF_SX12xx_DIO4() READ_BOARD_GPIOF()
#define READ_RF_SX12xx_DIO5() READ_BOARD_GPIOG()
#define RF_SX12xx_DIO0_H() BOARD_GPIOB_H()
#define RF_SX12xx_DIO0_L() BOARD_GPIOB_L()
#define RF_SX12xx_DIO1_H() BOARD_GPIOC_H()
#define RF_SX12xx_DIO1_L() BOARD_GPIOC_L()
#define RF_SX12xx_DIO2_H() BOARD_GPIOD_H()
#define RF_SX12xx_DIO2_L() BOARD_GPIOD_L()
#define RF_SX12xx_DIO3_H() BOARD_GPIOE_H()
#define RF_SX12xx_DIO3_L() BOARD_GPIOE_L()
#define RF_SX12xx_DIO4_H() BOARD_GPIOF_H()
#define RF_SX12xx_DIO4_L() BOARD_GPIOF_L()
#define RF_SX12xx_DIO5_H() BOARD_GPIOG_H()
#define RF_SX12xx_DIO5_L() BOARD_GPIOG_L()

#define RF_SX12xx_RST_H() BOARD_GPIOA_H()
#define RF_SX12xx_RST_L() BOARD_GPIOA_L()


void BOARD_SPI_NSS_H(void);
void BOARD_SPI_NSS_L(void);

void BOARD_GPIOA_H(void);
void BOARD_GPIOA_L(void);
void BOARD_GPIOB_H(void);
void BOARD_GPIOB_L(void);
void BOARD_GPIOC_H(void);
void BOARD_GPIOC_L(void);
void BOARD_GPIOD_H(void);
void BOARD_GPIOD_L(void);
void BOARD_GPIOE_H(void);
void BOARD_GPIOE_L(void);
void BOARD_GPIOF_H(void);
void BOARD_GPIOF_L(void);
void BOARD_GPIOG_H(void);
void BOARD_GPIOG_L(void);
void BOARD_GPIOH_H(void);
void BOARD_GPIOH_L(void);
uint8_t READ_BOARD_GPIOA(void);
uint8_t READ_BOARD_GPIOB(void);
uint8_t READ_BOARD_GPIOC(void);
uint8_t READ_BOARD_GPIOD(void);
uint8_t READ_BOARD_GPIOE(void);
uint8_t READ_BOARD_GPIOF(void);
uint8_t READ_BOARD_GPIOG(void);
uint8_t READ_BOARD_GPIOH(void);

void myRadio_gpio_init(void);
uint8_t SpiReadWrite(uint8_t byteToWrite);
void SpiWriteData(uint8_t byteCount,uint8_t* pData);
void SpiReadData(uint8_t byteCount,uint8_t* pData);

#endif
